CON
'
' NOTE: The following constants MUST MATCH the values in the threaded 
'       CMM kernel, and in catalina_threads.h !!!
'
dlsb       = $26
t1         = $27
t2         = $28
t3         = $29
t4         = $2a
t5         = $2b
t6         = $2c
switch     = $158
ticks      = $159
flags      = $15a
lock       = $15b
TP         = $15c
reg        = $15d
req        = $15e
'
' void * _thread_id();
'    return unique id of current thread 
' on exit:
'    r0 = thread id
'
' Catalina Code

DAT ' code segment

' Catalina Export _thread_id

        long    ' align long

C__thread_id
        long    I32_MOV + r0<<D32 + TP<<S32 ' return current thread id
        word    I16B_RETN
'
' LMM PASM implementations of fundamental multi-threading operations
'
' int _thread_get_lock();
'    return lock allocated for context switching 
' on exit:
'    r0 = lock in use (0 .. 7)
'
' Catalina Code

DAT ' code segment

' Catalina Export _thread_get_lock

        long    ' align long

C__thread_get_lock
        long    I32_MOV + r0<<D32 + lock<<S32 ' return lock currently allocated
        word    I16B_RETN

' end C__thread_get_lock

'
' void _thread_set_lock(int lock);
'    set lock to use for context switching (note this does not
'    release any previous lock - that must be done manually
'    by calling _thread_get_lock() and then _lockclr() on the result)
' on entry:
'    r2 = lock to use (0 .. 7)
'
'
' Catalina Code

DAT ' code segment

' Catalina Export _thread_set_lock

        long    ' align long

C__thread_set_lock
        long    I32_MOV + lock<<D32 + r2<<S32 ' set lock to use
        word    I16B_RETN

' end C__thread_set_lock

' Catalina Code

DAT ' code segment

' Catalina Export _context_switch

        long    ' align long

C__context_switch
        word    I16B_EXEC       ' start executing LMM
        mov     ticks,#100      ' in case we cannot get lock, set up ticks to wait before retry
        muxc    flags,#1        ' save C ...
        muxnz   flags,#2        ' ... and Z flags
        lockset lock wc         ' have we acquired the context switch lock?
 if_c   add     PC,#(@C__context_resume-@:switch_0) ' no - cannot switch, so restore C & Z and resume
:switch_0 
        rdlong  t2,TP           ' yes - load next thread block pointer
        rdlong  t1,req wz       ' is there an affinity request oustanding?
 if_nz  add     PC,#(@C__context_affine-@:switch_1) ' yes - service it
:switch_1 
        cmp     t2,TP wz        ' no - is there only one thread executing?
 if_z   add     PC,#(@C__context_unlock-@C__context_do_switch) ' yes - restore C & Z flags, unlock and resume
C__context_do_switch
        mov     t3,t2           ' no - get ...
        add     t3,#33*4+1      ' ... affinity byte 
        rdbyte  t1,t3           ' ... of proposed next thread
        test    t1,#%11100000 wz ' affinity stop, or thread terminated or completed?
  if_z  add     PC,#(@C__context_next-@:switch_2) ' no - switch to next thread
:switch_2
        or      t1,#%10000000   ' yes - make sure ...
        wrbyte  t1,t3           ' ... thread terminated bit of next thread is set
        rdlong  t2,t2           ' remove next thread ...
        wrlong  t2,TP           ' ... from the executing thread list
C__context_next
        add     ticks,#1        ' ensure we do not switch at this point!
        jmp     #EXEC_STOP      ' switch ...
        word    I16B_FCACHE + ((@:fc_code_end-@:fc_code_start)/4)<<S16B ' ... to FCACHE mode
        long    'align long
'************* START OF FCACHE ***************
:fc_code_start
        mov     t1,TP           ' point to ...  
        add     t1,#4           ' ... current thread register save area
        mov     PC,t6           ' including original PC (saved in t6)
        movd    FC_START+(@:save-@:fc_code_start)/4,#R0 ' :save, #R0      ' starting from R0  ...
        mov     t3,#32          ' ... save 32 registers
:save   wrlong  0-0,t1
        add     t1,#4
        add     FC_START+(@:save-@:fc_code_start)/4,dlsb ' :save,dlsb
        djnz    t3,#FC_START+(@:save-@:fc_code_start)/4 ' #:save
        wrbyte  flags,t1        ' save C & Z flags
        mov     TP,t2           ' set TP to next thread block
        add     t2,#4           ' point to that thread's register save area
        movd    FC_START+(@:load-@:fc_code_start)/4,#R0 ' :load, #R0      ' starting from R0 ...
        mov     t3,#32          ' ... load 32 registers
:load   rdlong  0-0,t2
        add     t2,#4
        add     FC_START+(@:load-@:fc_code_start)/4,dlsb ' :load,dlsb
        djnz    t3,#FC_START+(@:load-@:fc_code_start)/4 ' #:load
        rdbyte  flags,t2        ' load C & Z flags
        add     t2,#2           ' load ...
        rdword  ticks,t2 wz     ' ... tick count assigned to this thread ...
   if_z mov     ticks,#100      ' ... (use default tick count if zero)
        lockclr lock            ' release the context switch lock
        shr     flags,#1 wc,wz  ' restore Z & C flags
        jmp     #FC_INLINE      ' end of FCACHE code (will resume at PC as CMM)
:fc_code_end
'************* END OF FCACHE ***************
        ' align long
C__context_unlock        
        lockclr lock            ' release the context switch lock
C__context_resume
        shr     flags,#1 wc,wz  ' restore Z & C flags
        add     ticks,#1        ' ensure we do not switch at this point!
        jmp     #EXEC_STOP      ' stop executing LMM, resume executing CMM
        long    I32_MOV + PC<<D32 + t6<<S32 ' restore original PC (i.e. resume)
        ' align long
C__context_affine
        cmp     t2,TP wz        ' is there only one thread executing?
 if_nz  rdlong  t3,t2           ' no - get next thread of next thread ...        
 if_nz  wrlong  t3,t1           ' no - ... and make it next thread of new thread
 if_z   wrlong  t2,t1           ' yes - make new thread next thread of current thread 
        wrlong  t1,t2           ' make current thread next thread of new thread 
        mov     t4,#33*4+1      ' update ...
        add     t4,t1           ' ...
        rdbyte  t5,t4           ' ...
        cogid   t1              ' ...
        andn    t5,#%111        ' ...
        or      t5,t1           ' ...
        wrbyte  t5,t4           ' ... thread affinity
        mov     t4,#0           ' zero ...
        wrlong  t4,req          ' ... request block
        sub     PC,#(@:switch_3-@C__context_do_switch) ' now switch to next thread
:switch_3

' end C__context_switch

'
' Catalina Code

DAT ' code segment

' Catalina Export _thread_force_switch

        long    ' align long

C__thread_force_switch
        word    I16B_EXEC
        mov     t6,PC ' after executing this instruction, t6 will contain :switch_6
:switch_6
        add     t6,#(@:switch_5-@:switch_6-4) ' tweak t6 to be :switch_5 (- 4) 
        muxc    flags,#1        ' force context switch - save C ...
        muxnz   flags,#2        ' ... and Z flags
        rdlong  t2,TP           ' load next thread pointer
        cmp     t2,TP wz        ' is there only one thread executing?
 if_nz  sub     PC,#(@:switch_4-@C__context_do_switch) ' no - perform context switch
:switch_4 
        sub     PC,#(@:switch_5-@C__context_unlock) ' yes - unlock, restore C & Z amd resume
:switch_5        
        word    I16B_RETN

' end C__thread_force_switch

'
' Catalina Code

DAT ' code segment

' Catalina Export _inject_context_switch
'
' _inject_context_switch : setup context switching (used by dynamic kernel)

        long    ' align long

C__inject_context_switch
        long     I32_MOVI + r0<<D32 + switch<<S32   ' calculate ...
        word     I16A_SHLI + r0<<D16A + 2<<S16A     ' ... address in kernel image ...
        word     I16A_ADD + r0<<D16A + r2<<S16A     ' ... to inject switch function
        long     I32_LODA + @C__context_switch<<S32 ' inject ...
        word     I16A_WRLONG + RI<<D16A + r0<<S16A  ' ... context switch
        word     I16B_RETN

' end C__inject_context_switch

'
' Catalina Code

DAT ' code segment

' Catalina Export thread_setup
'
' thread_setup : setup context switching (used by non-dynamic kernel)
'
C_thread_setup
 long I32_LODA + @C__context_switch<<S32 ' point to context switch address
 long I32_MOV + SWITCH<<D32 + RI<<S32   ' set it in kernel
 word I16B_RETN             ' done
 long ' align long

' end C_thread_setup
